
package com.kingdee.eas.custom.hireapproval.web;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.operamasks.faces.annotation.Inject;
import org.operamasks.faces.annotation.ManagedBean;
import org.operamasks.faces.annotation.ManagedBeanScope;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.MetaDataPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.waf.annotation.IBOSBizCtrl;
import com.kingdee.bos.waf.util.OperateState;
import com.kingdee.bos.waf.winlet.edit.EditBean;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.framework.ICoreBase;
import org.operamasks.faces.annotation.Accessible;
import org.operamasks.faces.component.form.impl.*;
import com.kingdee.bos.waf.action.AbstractWebAction;
import javax.faces.event.AbortProcessingException;
import javax.faces.context.FacesContext;
import org.operamasks.faces.component.action.ActionEvent;
import org.operamasks.faces.annotation.Action;
import com.kingdee.bos.waf.winlet.BaseBean;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;

import com.kingdee.eas.custom.hireapproval.IOAHireSalaryData;
import com.kingdee.eas.custom.hireapproval.OAHireSalaryDataInfo;
import com.kingdee.eas.custom.hireapproval.OAHireSalaryDataEntryInfo;
import com.kingdee.eas.custom.hireapproval.OAHireSalaryDataEntryCollection;

public abstract class AbstractOAHireSalaryDataEditUIBean extends com.kingdee.bos.waf.winlet.edit.EditBean {

	@IBOSBizCtrl
	protected com.kingdee.eas.custom.hireapproval.IOAHireSalaryData service;

	@Inject("custom.hireapproval.OAHireSalaryDataEntryBean")
	protected OAHireSalaryDataEntryBean oAHireSalaryDataEntryBean;
	public AbstractOAHireSalaryDataEditUIBean() {
		super();
	}

	
	
	@Override
	public void createNewModel() {
		model = new OAHireSalaryDataInfo();
	}

	@Override
	public void pageOnload() {
		super.pageOnload();
		
		OAHireSalaryDataEntryCollection entryCol_0 = ((OAHireSalaryDataInfo) model).getEntrys();

		List<CoreBaseInfo> listModel_0 = new LinkedList<CoreBaseInfo>();
		if (entryCol_0 != null)
		{
			for (int i = 0, n = entryCol_0.size(); i < n; i++) {
				listModel_0.add(entryCol_0.get(i));
			}
	
			oAHireSalaryDataEntryBean.setListModel(listModel_0);
		}

		
	}

	@Override
	public void saveModel() {
		updateModel();
		super.saveModel();
	}

	@Override
	public void submitModel() {
		updateModel();
		super.submitModel();
	}


	protected void updateModel() {
		
		if (oAHireSalaryDataEntryBean == null)
			oAHireSalaryDataEntryBean = (OAHireSalaryDataEntryBean) com.kingdee.bos.waf.util.BeanUtil
					.getBean("custom.hireapproval.OAHireSalaryDataEntryBean");

		oAHireSalaryDataEntryBean.updataModel();
		List<CoreBaseInfo> entryModel_0 = oAHireSalaryDataEntryBean.getListModel();
		((OAHireSalaryDataInfo) model).getEntrys().clear();
		if (entryModel_0 != null) {
			for (CoreBaseInfo entryInfo : entryModel_0) {
				((OAHireSalaryDataInfo) model).getEntrys().add(
						(OAHireSalaryDataEntryInfo) entryInfo);
			}
		}

	}
	
	
	//entry
	public void oAHireSalaryDataEntryBean_apendRow(){
		oAHireSalaryDataEntryBean.appendRow();
	}
	public void oAHireSalaryDataEntryBean_removeRow(){
		oAHireSalaryDataEntryBean.removeRow();
	}
		

	@Override
	protected ICoreBase getBizInterface() {
		return service;
	}
	
	@Override
	public IMetaDataPK getMetaDataPK() {
		return new MetaDataPK("com.kingdee.eas.custom.hireapproval.web.OAHireSalaryDataEditUI");
	}
	
	@Override
	protected String getEntryPKName() {
	
		return "entrys.id";
	
	}

	@Override
	public SelectorItemCollection getSelectors() {
		SelectorItemCollection sic = super.getSelectors();
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("bizDate"));
        sic.add(new SelectorItemInfo("handler.*"));
        sic.add(new SelectorItemInfo("description"));
        sic.add(new SelectorItemInfo("auditor.*"));
        sic.add(new SelectorItemInfo("entrys.id"));
        sic.add(new SelectorItemInfo("entrys.cmpItem.*"));
        sic.add(new SelectorItemInfo("entrys.money"));
        sic.add(new SelectorItemInfo("entrys.oAEffectDate"));
        sic.add(new SelectorItemInfo("entrys.currency.*"));
        sic.add(new SelectorItemInfo("idNumber"));
        sic.add(new SelectorItemInfo("passport"));
        sic.add(new SelectorItemInfo("oaNumber"));
        sic.add(new SelectorItemInfo("executeResult"));
        sic.add(new SelectorItemInfo("executeStatus"));
        sic.add(new SelectorItemInfo("insFundCity"));
        sic.add(new SelectorItemInfo("socialLevel"));
        sic.add(new SelectorItemInfo("insFundBase"));
        sic.add(new SelectorItemInfo("hrOrgUnit.*"));
        sic.add(new SelectorItemInfo("salaryCalcType"));
        sic.add(new SelectorItemInfo("personName"));
        sic.add(new SelectorItemInfo("department"));
	
		return sic;
	}			
    	protected String getTDTemplateName() {
	    	return "/bim/custom/hireapproval/OAHireSalaryData";
		}
	    protected com.kingdee.bos.metadata.IMetaDataPK getTDQueryPK() {
	    	return new com.kingdee.bos.metadata.MetaDataPK("com.kingdee.eas.custom.hireapproval.app.OAHireSalaryDataQuery");
	    }

}
